#
# NMAKE-compatible MAKE file for building REXX/SQL with C Set/2
#
# will generate:
#
#      rexxsql.dll
#      rexxsql.exe
#      rexx<db>.dll
#      rexx<db>.exe
# 
# Usage: nmake [DEBUG=1] 
#              [DB=SAW|ODBC|UDBC|ORA|MIN|DB2|SYB|MIN2|SOL]
#              [LOAD=DYNAMIC]
#              [rexxsql.dll|rexxsql.exe|rexx<db>.dll|rexx<db>.exe]
#

VERDOT = 2.4
SRC = c:/RexxSQL-$(VERDOT)

#---------------------------------------------------------------------
# You should not have to change anything below here...
#---------------------------------------------------------------------


MYLDEXTRA = emxbind
OBJ=o
#
# Database specific defines
#
BDB = $(DB)
ifeq ($(DB),ORA)
LDB = ora
DBDEFINE = /DORA_PREFIX
DBDIR=$(SRC)\$(DB)
CLIDIR=$(DBDIR)
CLI=ora
DBLIBS = rexx+ora7o32
EXTRAINC =

else
ifeq ($(DB),DB2)
LDB = db2
DBDEFINE = -DDB2_PREFIX
DBDIR=$(SRC)\$(DB)
CLIDIR=$(SRC)/cli-odbc
CLI=rexxcli
OBJ=obj
DBLIBSEXE = -Zomf -lc:/sqllib/lib/db2cli.lib
DBLIBSDLL = $(DBLIBSEXE)
EXTRAINC = -Zomf -Ic:/sqllib/include
MYLDEXTRA = echo

else
ifeq ($(DB),SAW)
LDB = saw
DBDEFINE = -DSAW_PREFIX
DBDIR=$(SRC)/$(DB)
CLIDIR=$(SRC)/cli-odbc
CLI=rexxcli
OBJ=obj
DBLIBSEXE = -Zomf -lc:/sqlany50/os2/lib/wodbc2
DBLIBSDLL = $(DBLIBSEXE)
EXTRAINC = -Zomf -Ic:/sqlany50/h
MYLDEXTRA = echo

else
ifeq ($(DB),MIN)
db = min
DBDEFINE = /DMIN_PREFIX
DBDIR=$(SRC)\$(DB)
CLIDIR=$(SRC)\$(DB)
CLI=min
DBLIBS = rexx+c:\public\msql\lib\msql_dll.lib+c:\tcpip\lib\so32dll.lib+c:\tcpip\lib\tcp32dll.lib
EXTRAINC = -Ic:\public\msql\include

else
ifeq ($(DB),MY)
LDB = my
DBDEFINE = -DMY_PREFIX
DBDIR=$(SRC)/$(LDB)
CLIDIR=$(SRC)/$(LDB)
CLI=my
DBLIBSEXE = -Lc:/mysql2/lib/st -llibmysqlclient -lsocket
DBLIBSDLL = -Lc:/mysql2/lib/st -lmysqlclient -lsocket
EXTRAINC = -Ic:/mysql2/include

else
ifeq ($(DB),MIN2)
LDB = min
DBDEFINE = -DMIN_PREFIX
DBDIR=$(SRC)/min2
CLIDIR=$(SRC)/min2
CLI=min
DBLIBSEXE = -Lc:/public/msql2/lib -llibmsql
DBLIBSDLL = -Lc:/public/msql2/lib -lmsql
EXTRAINC = -Ic:/public/msql2/include

else
ifeq ($(DB),ODBC)
LDB = odbc
DBDEFINE = /DODBC_PREFIX
DBDIR=$(SRC)\$(DB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = rexx+e:\mhes\odbcsdk.30\odbc32.lib
EXTRAINC = /Ie:\mhes\odbcsdk.30

else
ifeq ($(DB),UDBC)
db = udbc
DBDEFINE = /DUDBC_PREFIX
DBDIR=$(SRC)\$(DB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = rexx+h:\udbc\lib\opludbc.lib
EXTRAINC = /Ih:\udbc\include

else
ifeq ($(DB),SYB)
db = syb
DBDEFINE = /DSYB_PREFIX
DBDIR=$(SRC)\$(DB)
CLIDIR=$(DBDIR)
CLI=syb
DBLIBS = rexx+e:\sql10\lib\libct+e:\sql10\lib\libcs
EXTRAINC = /Ie:\sql10\include
else
ifeq ($(DB),SOL)
db = sol
DBDEFINE = /DSOL_PREFIX
DBDIR=$(SRC)\$(DB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = rexx+h:\ss\lib\SCLO3222.LIB
EXTRAINC = /Ih:\ss\include /DSOLID_SERVER
else
error Target Database NOT specified via DB macro. Valid values are: ORA SAW ODBC MIN MIN2 DB2 SYB SOL
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif

INCCOMDIR = $(SRC)/common
INCDBDIR = $(DBDIR)
CC2O = -o $@

EXTRALINK =
DISTDIR=$(SRC)\dist
CC = gcc
LINK = gcc

comcopts = -D__OS2__ -DSTDC_HEADERS -DUSE_OS2REXX -DHAVE_PROTO -I$(DBDIR) -I$(SRC)/common $(EXTRAINC) #-DOS2
comlopts = $(EXTRALINK)

ifeq ($(DEBUG),Y)
copts     = -c -g -Wall $(comcopts) -DDEBUG
lopts     = -g
else
copts     = -c -O3 -fomit-frame-pointer -Wall $(comcopts)
lopts     = -O3 -fomit-frame-pointer
endif

cflagsdll = $(copts) -DDYNAMIC -Zdll -Zcrtdll -Zomf
cflagsexe = $(copts) 
lflagsdll = $(lopts) -Zdll -Zcrtdll -Zomf
lflagsexe = $(lopts) 

SSQLOBJS = loader.$(OBJ) $(CLI).$(OBJ) hash.$(OBJ) util.$(OBJ) rxpack.$(OBJ)
SDBOBJS = loader_$(LDB).$(OBJ) $(CLI)_$(LDB).$(OBJ) hash.$(OBJ) util_$(LDB).$(OBJ) rxpack_$(LDB).$(OBJ)
DSQLOBJS = $(CLI)_dyn.$(OBJ) hash_dyn.$(OBJ) util_dyn.$(OBJ) rxpack_dyn.$(OBJ)
DDBOBJS = $(CLI)_$(LDB)_dyn.$(OBJ) hash_dyn.$(OBJ) util_$(LDB)_dyn.$(OBJ) rxpack_$(LDB)_dyn.$(OBJ)

ccsqldll = gcc $(cflagsdll) $(listopt)
ccsqlexe = gcc $(cflagsexe) $(listopt)
ccdbdll = gcc $(cflagsdll) $(listopt) $(DBDEFINE)
ccdbexe = gcc $(cflagsexe) $(listopt) $(DBDEFINE)

H1=$(INCCOMDIR)/rexxsql.h $(INCCOMDIR)/defines.h
H2=$(INCDBDIR)/dbdefine.h $(INCDBDIR)/dbheader.h $(INCDBDIR)/dbtypes.h
H3=$(INCCOMDIR)/common.h
H4=$(INCCOMDIR)/hash.h
H5=$(INCCOMDIR)/rxpack.h $(INCCOMDIR)/rxdef.h

all: rexxsql.exe rexxsql.dll rexx$(LDB).exe rexx$(LDB).dll

rexxsql.exe: $(SSQLOBJS) $(GETOPT)
	$(LINK) $(LDFLAGS) -o rexxsql $(SSQLOBJS) $(DBLIBSEXE)
	$(MYLDEXTRA) rexxsql
	rc $(SRC)\rexxsql_os2.res rexxsql.exe

rexx$(LDB).exe: $(SDBOBJS)
	$(LINK) $(LDFLAGS) -o rexx$(LDB) $(SDBOBJS) $(DBLIBSEXE)
	$(MYLDEXTRA) rexx$(LDB)
	rc $(SRC)\rexxsql_os2.res rexx$(LDB).exe

rexxsql.dll: $(DSQLOBJS)
	$(LINK) $(lflagsdll) -o $@ $(DSQLOBJS) $(DBLIBSDLL) $(SRC)/rexxsql_os2_dll.def
	rc $(SRC)\rexxsql_os2.res rexxsql.dll

rexx$(LDB).dll: $(DDBOBJS) $(RXPACKEXP2)
	$(LINK) $(lflagsdll) -o $@ $(DDBOBJS) $(DBLIBSDLL) $(SRC)/rexx$(LDB)_os2_dll.def
	rc $(SRC)\rexxsql_os2.res rexx$(LDB).dll


hash.$(OBJ): $(INCCOMDIR)/hash.c $(H4)
	$(CC) $(cflagsexe) $(CC2O) $(INCCOMDIR)/hash.c

hash_dyn.$(OBJ): $(INCCOMDIR)/hash.c $(H4)
	$(CC) $(cflagsdll) $(CC2O) $(INCCOMDIR)/hash.c

rxpack.$(OBJ): $(INCCOMDIR)/rxpack.c $(H5)
	$(CC) $(cflagsexe) $(CC2O) $(INCCOMDIR)/rxpack.c

rxpack_dyn.$(OBJ): $(INCCOMDIR)/rxpack.c $(H5)
	$(CC) $(cflagsdll) $(CC2O) $(INCCOMDIR)/rxpack.c

rxpack_$(LDB).$(OBJ): $(INCCOMDIR)/rxpack.c $(H5)
	$(CC) $(cflagsexe) $(DBDEFINE) $(CC2O) $(INCCOMDIR)/rxpack.c

rxpack_$(LDB)_dyn.$(OBJ): $(INCCOMDIR)/rxpack.c $(H5)
	$(CC) $(cflagsdll) $(DBDEFINE) $(CC2O) $(INCCOMDIR)/rxpack.c

util.$(OBJ): $(INCCOMDIR)/util.c $(H1) $(H2)
	$(CC) $(cflagsexe) $(CC2O) $(INCCOMDIR)/util.c

util_$(LDB).$(OBJ): $(INCCOMDIR)/util.c $(H1) $(H2)
	$(CC) $(cflagsexe) $(DBDEFINE) $(CC2O) $(INCCOMDIR)/util.c

util_dyn.$(OBJ): $(INCCOMDIR)/util.c $(H1) $(H2)
	$(CC) $(cflagsdll) $(CC2O) $(INCCOMDIR)/util.c

util_$(LDB)_dyn.$(OBJ): $(INCCOMDIR)/util.c $(H1) $(H2)
	$(CC) $(cflagsdll) $(DBDEFINE) $(CC2O) $(INCCOMDIR)/util.c

loader.$(OBJ): $(INCCOMDIR)/loader.c $(H1) $(H2)
	$(CC) $(cflagsexe) $(CC2O) $(INCCOMDIR)/loader.c

loader_$(LDB).$(OBJ): $(INCCOMDIR)/loader.c $(H1) $(H2)
	$(CC) $(cflagsexe) $(DBDEFINE) $(CC2O) $(INCCOMDIR)/loader.c

rexxsql_dyn.$(OBJ): $(INCCOMDIR)/rexxsql.c $(H1) $(H2)
	$(CC) $(cflagsdll) $(CC2O) $(INCCOMDIR)/rexxsql.c

rexxsql_$(LDB)_dyn.$(OBJ): $(INCCOMDIR)/rexxsql.c $(H1) $(H2)
	$(CC) $(cflagsdll) $(DBDEFINE) $(CC2O) $(INCCOMDIR)/rexxsql.c

$(CLI).$(OBJ): $(CLIDIR)/$(CLI).c $(H1) $(H2) $(H3)
	$(CC) $(cflagsexe) $(CC2O) $(CLIDIR)/$(CLI).c

$(CLI)_$(LDB).$(OBJ): $(CLIDIR)/$(CLI).c $(H1) $(H2) $(H3)
	$(CC) $(cflagsexe) $(DBDEFINE) $(CC2O) $(CLIDIR)/$(CLI).c

$(CLI)_dyn.$(OBJ): $(CLIDIR)/$(CLI).c $(H1) $(H2) $(H3)
	$(CC) $(cflagsdll) $(CC2O) $(CLIDIR)/$(CLI).c

$(CLI)_$(LDB)_dyn.$(OBJ): $(CLIDIR)/$(CLI).c $(H1) $(H2) $(H3)
	$(CC) $(cflagsdll) $(DBDEFINE) $(CC2O) $(CLIDIR)/$(CLI).c



#rexxsql.dll: $(objssqldll)
#	link386 $(lflagsdll) utsqldll.o+hashdll.o+rxsqldll.o,$@,$*.map,$(DBLIBS),$(SRC)\rexxsql_os2_dll.def;
#	rc $(SRC)\rexxsql_os2.res rexxsql.dll

#rexxsql.exe: $(objssqlexe)
#	link386 $(lflagsexe) utsqlexe.o+rxsql.o+hashexe.o+rxsqlexe.o+getopt.o,$@,$*.map,$(DBLIBS),$(SRC)\rexxsql_os2_exe.def;
#	rc $(SRC)\rexxsql_os2.res rexxsql.exe

#rexx$(db).dll: $(objsdbdll)
#	link386 $(lflagsdll) ut$(db)dll.o+hashdll.o+rx$(db)dll.o,$@,$*.map,$(DBLIBS),$(SRC)\rexx$(db)_os2_dll.def;
#	rc $(SRC)\rexxsql_os2.res rexx$(db).dll

#rexx$(db).exe: $(objsdbexe)
#	link386 $(lflagsexe) ut$(db)exe.o+rx$(db).o+hashexe.o+rx$(db)exe.o+getopt.o,$@,$*.map,$(DBLIBS),$(SRC)\rexx$(db)_os2_exe.def;
#	rc $(SRC)\rexxsql_os2.res rexx$(db).exe

dist: $(DISTDIR)\$(DB)\rexxsql.exe $(DISTDIR)\$(DB)\rexxsql.dll $(DISTDIR)\$(DB)\rexx$(db).exe $(DISTDIR)\$(DB)\rexx$(db).dll

$(DISTDIR)\$(DB)\rexxsql.exe: rexxsql.exe
	copy rexxsql.exe $(DISTDIR)\$(DB)

$(DISTDIR)\$(DB)\rexxsql.dll: rexxsql.dll
	copy rexxsql.dll $(DISTDIR)\$(DB)

$(DISTDIR)\$(DB)\rexx$(db).exe: rexx$(db).exe
	copy rexx$(db).exe $(DISTDIR)\$(DB)

$(DISTDIR)\$(DB)\rexx$(db).dll: rexx$(db).dll
	copy rexx$(db).dll $(DISTDIR)\$(DB)
