#
# NMAKE-compatible MAKE file for building REXX/SQL with VC++
#
# will generate:
#
#      rexxsql.dll
#      rexxsql.exe
#      rexx<db>.dll
#      rexx<db>.exe
# 
# Usage: nmake [DEBUG=1] 
#              [INT=REGINA|OREXX|WINREXX|QUERCUS|REXXTRANS]
#              [DB=SAW|ODBC|UDBC|ORA|MIN|DB2|SYB|MIN2|SOL|MY|VEL]
#              [rexxsql.dll|rexxsql.exe|rexx<db>.dll|rexx<db>.exe]
#

SRC = $(REXXSQL_SRCDIR)
DISTDIR=$(SRC)

ORA_DBLIBS = $(ORA_HOMEDIR)\lib\msvc\ociw32.lib
ORA_DBINC =
DB2_DBLIBS = $(DB2_HOMEDIR)\lib\db2cli.lib
DB2_DBINC = /I$(DB2_HOMEDIR)\include
SAW_DBLIBS = $(SAW_HOMEDIR)\win32\lib\odbc32.lib
SAW_DBINC = /I$(SAW_HOMEDIR)\h #/If:\sqlany50\h
MIN2_DBLIBS = $(MIN2_HOMEDIR)\lib\msql_dll.lib wsock32.lib advapi32.lib
MIN2_DBINC = /I$(MIN2_HOMEDIR)\include
MIN_DBLIBS = $(MIN_HOMEDIR)\lib\msql_dll.lib wsock32.lib advapi32.lib
MIN_DBINC = /I$(MIN_HOMEDIR)\include
ODBC_DBLIBS = $(ODBC_HOMEDIR)\odbc32.lib
ODBC_DBINC = /I$(ODBC_HOMEDIR)
UDBC_DBLIBS = $(UDBC_HOMEDIR)\lib\librpc.lib $(UDBC_HOMEDIR)\lib\opludb32.lib wsock32.lib
UDBC_DBINC = /I$(UDBC_HOMEDIR)\include /MT
SOL_DBLIBS = $(SOL_HOMEDIR)\lib\SCLW3223.LIB
SOL_DBINC = /I$(SOL_HOMEDIR)\include /DSS_NT /DSOLID_SERVER
MY_DBLIBS = $(MY_HOMEDIR)\lib\debug\mysqlclient.lib wsock32.lib advapi32.lib
MY_DBINC = /I$(MY_HOMEDIR)\include /MTd
VEL_DBLIBS = $(VEL_HOMEDIR)\lib\rdscli.lib wsock32.lib advapi32.lib
VEL_DBINC = /I$(VEL_HOMEDIR)\include /MD /DNT_INTEL /DWIN32_NT /DNT /DMSC /DVELOCIS

REGINA_REXXLIBS = $(REGINA_SRCDIR)\vc\regina.lib
REGINA_REXXINC = -I$(REGINA_SRCDIR) -DUSE_REGINA
OREXX_REXXLIBS = $(OREXX_SRCDIR)\api\rexx.lib $(OREXX_SRCDIR)\api\rexxapi.lib
OREXX_REXXINC = -I$(OREXX_SRCDIR)\api -DUSE_OREXX
WINREXX_REXXLIBS = f:\winrexx\api\rxrexx.lib
WINREXX_REXXINC = -If:\winrexx\api -DUSE_WINREXX
QUERCUS_REXXLIBS = f:\quercus\wrexx32.lib
QUERCUS_REXXINC = -If:\quercus -DUSE_QUERCUS
UNIREXX_REXXLIBS = f:\unirexx\api\rx.lib
UNIREXX_REXXINC = -If:\unirexx\api -DUSE_UNIREXX
REXXTRANS_REXXLIBS = $(REXXTRANS_SRCDIR)\vc\rexxtrans.lib
REXXTRANS_REXXINC = -I$(REXXTRANS_SRCDIR) -DUSE_REXXTRANS
#---------------------------------------------------------------------
# You should not have to change anything below here...
#---------------------------------------------------------------------

#
# Database specific defines
#
!if "$(DB)" == "ORA"
LDB = ora
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(DBDIR)
CLI=ora
DBLIBS = $(ORA_DBLIBS)
DBINC = $(ORA_DBINC)
DBDEFINE = /DORA_PREFIX

!elseif "$(DB)" == "DB2"
LDB = db2
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = $(DB2_DBLIBS)
DBINC = $(DB2_DBINC)
DBDEFINE = /DDB2_PREFIX

!elseif "$(DB)" == "SAW"
LDB = saw
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = $(SAW_DBLIBS)
DBINC = $(SAW_DBINC)
DBDEFINE = /DSAW_PREFIX

!elseif "$(DB)" == "VEL"
LDB = vel
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = $(VEL_DBLIBS)
DBINC = $(VEL_DBINC)
DBDEFINE = /DVEL_PREFIX

!elseif "$(DB)" == "MIN"
LDB = min
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(DBDIR)
CLI=min
DBLIBS = $(MIN_DBLIBS)
DBINC =  $(MIN_DBINC)
DBDEFINE = /DMIN_PREFIX

!elseif "$(DB)" == "MIN2"
LDB = min
DBDIR=$(SRC)\min2
CLIDIR=$(DBDIR)
CLI=min
DBLIBS = $(MIN2_DBLIBS)
DBINC =  $(MIN2_DBINC)
DBDEFINE = /DMIN_PREFIX

!elseif "$(DB)" == "MY"
LDB = my
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(DBDIR)
CLI=my
DBLIBS = $(MY_DBLIBS)
DBINC =  $(MY_DBINC)
DBDEFINE = /DMY_PREFIX

!elseif "$(DB)" == "ODBC"
LDB = odbc
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = $(ODBC_DBLIBS)
DBINC =  $(ODBC_DBINC)
DBDEFINE = /DODBC_PREFIX

!elseif "$(DB)" == "UDBC"
LDB = udbc
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = $(UDBC_DBLIBS)
DBINC =  $(UDBC_DBINC)
DBDEFINE = /DUDBC_PREFIX

!elseif "$(DB)" == "SOL"
LDB = sol
DBDIR=$(SRC)\$(LDB)
CLIDIR=$(SRC)\cli-odbc
CLI=rexxcli
DBLIBS = $(SOL_DBLIBS)
DBINC =  $(SOL_DBINC)
DBDEFINE = /DSOL_PREFIX

!elseif "$(DB)" == "SYB"
DBDEFINE = /DSYB_PREFIX
!else
!message Target Database NOT specified via DB macro
!message Valid values are: ORA SAW ODBC MIN DB2 SYB SOL MY MIN2
!error Make aborted!
!endif

#
# Interpreter specific defines
#
!if "$(INT)" == "REGINA"
REXXLIBS = $(REGINA_REXXLIBS)
REXXINC =  $(REGINA_REXXINC)
!elseif "$(INT)" == "OREXX"
REXXLIBS = $(OREXX_REXXLIBS)
REXXINC =  $(OREXX_REXXINC)
!elseif "$(INT)" == "WINREXX"
REXXLIBS = $(WINREXX_REXXLIBS)
REXXINC =  $(WINREXX_REXXINC)
!elseif "$(INT)" == "QUERCUS"
REXXLIBS = $(QUERCUS_REXXLIBS)
REXXINC =  $(QUERCUS_REXXINC)
!elseif "$(INT)" == "UNIREXX"
REXXLIBS = $(UNIREXX_REXXLIBS)
REXXINC =  $(UNIREXX_REXXINC)
!elseif "$(INT)" == "REXXTRANS"
REXXLIBS = $(REXXTRANS_REXXLIBS)
REXXINC =  $(REXXTRANS_REXXINC)
!else
!message Rexx Interpreter NOT specified via INT macro
!message Valid values are: REGINA OREXX WINREXX QUERCUS UNIREXX REXXTRANS
!error Make aborted!
!endif

INCCOMDIR = $(SRC)\common
INCDBDIR = $(DBDIR)
INCSRCDIR = $(CLIDIR)
CC20 = -o $@
MYLDEXTRA = emxbind

EXTRALINK =
CCLIBS = user32.lib
CC = cl
LINK = link
GETOPT = getopt.obj
CC2O = /Fo$@

comcopts = -nologo -W3 -c -DWIN32 -DHAVE_PROTO  -I$(DBDIR) -I$(SRC)\common $(DBINC) $(REXXINC)
comlopts = -nologo -machine:I386 $(EXTRALINK) #/NOI /NOE /NOLOGO /EXEPACK:2 /ALIGN:4 $(EXTRALINK)

!ifdef DEBUG
copts  = $(comcopts) -Od -Zi -FR -DDEBUG
lopts  = $(comlopts) -debug #-debugtype:coff -fixed:no #-pdb:none
!else
copts  = $(comcopts) -Ox
lopts  = $(comlopts) -release
!endif

cflagsdll = $(copts) -DDYNAMIC
cflagsexe = $(copts) 
lflagsdll = $(lopts) -dll -implib:$(*B).lib
lflagsexe = $(lopts) 

SSQLOBJS = $(GETOPT) loader.obj $(CLI).obj hash.obj util.obj rxpack.obj exe_res.obj
SDBOBJS = $(GETOPT) loader_$(LDB).obj $(CLI)_$(LDB).obj hash.obj util_$(LDB).obj rxpack.obj exe_res.obj
DSQLOBJS = $(CLI)_dyn.obj hash_dyn.obj util_dyn.obj rxpack_dyn.obj dll_res.obj
DDBOBJS = $(CLI)_$(LDB)_dyn.obj hash_dyn.obj util_$(LDB)_dyn.obj rxpack_dyn.obj dll_res.obj

#objssqldll = hashdll.obj rexxsql.obj dll_res.obj
#objssqlexe = getopt.obj hashexe.obj utsqlexe.obj rxsqlexe.obj loader.obj exe_res.obj
#objsdbdll = hashdll.obj ut$(db)dll.obj rx$(db)dll.obj dll_res.obj
#objsdbexe = getopt.obj hashexe.obj ut$(db)exe.obj rx$(db)exe.obj rx$(db).obj exe_res.obj

ccsqldll = $(CC) $(cflagsdll) $(listopt)
ccsqlexe = $(CC) $(cflagsexe) $(listopt)
ccdbdll = $(CC) $(cflagsdll) $(listopt) $(DBDEFINE)
ccdbexe = $(CC) $(cflagsexe) $(listopt) $(DBDEFINE)

H1=$(INCCOMDIR)\rexxsql.h $(INCCOMDIR)\defines.h
H2=$(INCDBDIR)\dbdefine.h $(INCDBDIR)\dbheader.h $(INCDBDIR)\dbtypes.h
H3=$(INCCOMDIR)\common.h
H4=$(INCCOMDIR)\hash.h
H5=$(INCCOMDIR)\rxpack.h $(INCCOMDIR)\rxdef.h

all: rexxsql.exe rexxsql.dll rexx$(LDB).dll rexx$(LDB).exe #dist

rexxsql.exe: $(SSQLOBJS) $(GETOPT)
	link $(lflagsexe) $(SSQLOBJS) -out:rexxsql.exe $(DBLIBS) $(CCLIBS) $(REXXLIBS)

rexx$(LDB).exe: $(SDBOBJS) $(GETOPT)
	link $(lflagsexe) $(SDBOBJS) -out:rexx$(LDB).exe $(DBLIBS) $(CCLIBS) $(REXXLIBS)

rexxsql.dll: $(DSQLOBJS)
	link $(lflagsdll) $(DSQLOBJS) -out:rexxsql.dll $(DBLIBS) $(CCLIBS) $(REXXLIBS) -def:$(SRC)\rexxsql_w32_dll.def

rexx$(LDB).dll: $(DDBOBJS)
	link $(lflagsdll) $(DDBOBJS) -out:rexx$(LDB).dll $(DBLIBS) $(CCLIBS) $(REXXLIBS) -def:$(SRC)\rexx$(LDB)_w32_dll.def


getopt.obj: $(SRC)\common\getopt.c
	$(ccsqlexe) $(CC2O) $(INCCOMDIR)\getopt.c

hash.obj: $(INCCOMDIR)\hash.c $(H4)
	$(ccsqlexe) $(CC2O) $(INCCOMDIR)\hash.c

hash_dyn.obj: $(INCCOMDIR)\hash.c $(H4)
	$(ccsqldll) $(CC2O) $(INCCOMDIR)\hash.c

rxpack.obj: $(INCCOMDIR)\rxpack.c $(H5)
	$(ccsqlexe) $(CC2O) $(INCCOMDIR)\rxpack.c

rxpack_dyn.obj: $(INCCOMDIR)\rxpack.c $(H5)
	$(ccsqldll) $(CC2O) $(INCCOMDIR)\rxpack.c

util.obj: $(INCCOMDIR)\util.c $(H1) $(H2) 
	$(ccsqlexe) $(CC2O) $(INCCOMDIR)\util.c

util_$(LDB).obj: $(INCCOMDIR)\util.c $(H1) $(H2) 
	$(ccdbexe) $(CC2O) $(INCCOMDIR)\util.c

util_dyn.obj: $(INCCOMDIR)\util.c $(H1) $(H2) 
	$(ccsqldll) $(CC2O) $(INCCOMDIR)\util.c

util_$(LDB)_dyn.obj: $(INCCOMDIR)\util.c $(H1) $(H2) 
	$(ccdbdll) $(CC2O) $(INCCOMDIR)\util.c

loader.obj: $(INCCOMDIR)\loader.c $(H1) $(H2)
	$(ccsqlexe) $(CC2O) $(INCCOMDIR)\loader.c

loader_$(LDB).obj: $(INCCOMDIR)\loader.c $(H1) $(H2)
	$(ccdbexe) $(CC2O) $(INCCOMDIR)\loader.c

rexxsql_dyn.obj: $(INCCOMDIR)\rexxsql.c $(H1) $(H2) 
	$(ccsqldll) $(CC2O) $(INCCOMDIR)\rexxsql.c

rexxsql_$(LDB)_dyn.obj: $(INCCOMDIR)\rexxsql.c $(H1) $(H2) 
	$(ccdbdll) $(CC2O) $(INCCOMDIR)\rexxsql.c

$(CLI).obj: $(INCSRCDIR)\$(CLI).c $(H1) $(H2) $(H3)
	$(ccsqlexe) $(CC2O) $(INCSRCDIR)\$(CLI).c

$(CLI)_$(LDB).obj: $(INCSRCDIR)\$(CLI).c $(H1) $(H2) $(H3)
	$(ccdbexe) $(CC2O) $(INCSRCDIR)\$(CLI).c

$(CLI)_dyn.obj: $(INCSRCDIR)\$(CLI).c $(H1) $(H2) $(H3)
	$(ccsqldll) $(CC2O) $(INCSRCDIR)\$(CLI).c

$(CLI)_$(LDB)_dyn.obj: $(INCSRCDIR)\$(CLI).c $(H1) $(H2) $(H3)
	$(ccdbdll) $(CC2O) $(INCSRCDIR)\$(CLI).c


#
# Rules for resources
#
exe_res.obj exe_res.res: $(SRC)\rexxsql_w32.rc
	copy $(SRC)\rexxsql_w32.ico .
	rc /r /foexe_res.res /D$(INT) /D$(DB) /i$(SRC) $(SRC)\rexxsql_w32.rc
	cvtres /MACHINE:IX86 /NOLOGO /OUT:exe_res.obj exe_res.res

dll_res.obj dll_res.res: $(SRC)\rexxsql_w32.rc
	copy $(SRC)\rexxsql_w32.ico .
	rc /r /fodll_res.res /DDYNAMIC /D$(INT) /D$(DB) /i$(SRC) $(SRC)\rexxsql_w32.rc
	cvtres /MACHINE:IX86 /NOLOGO /OUT:dll_res.obj dll_res.res

#
# Rules for executables and DLLs
#
#rexxsql.dll: $(objssqldll)
#	link $(lflagsdll) $(objssqldll) -out:rexxsql.dll $(DBLIBS) $(CCLIBS) $(REXXLIBS) -def:$(SRC)\rexxsql_w32_dll.def

#rexxsql.exe: $(objssqlexe)
#	link $(lflagsexe) $(objssqlexe) -out:rexxsql.exe $(DBLIBS) $(CCLIBS) $(REXXLIBS)

#rexx$(db).dll: $(objsdbdll)
#	link $(lflagsdll) $(objsdbdll) -out:rexx$(db).dll $(DBLIBS) $(CCLIBS) $(REXXLIBS) -def:$(SRC)\rexx$(db)_w32_dll.def

#
# Rules for distribution
#
dist: $(DISTDIR)\$(DB)\$(INT)\rexxsql.exe $(DISTDIR)\$(DB)\$(INT)\rexxsql.dll $(DISTDIR)\$(DB)\$(INT)\rexx$(db).dll

$(DISTDIR)\$(LDB)\$(INT)\rexxsql.exe: rexxsql.exe
	copy rexxsql.exe $(DISTDIR)\$(LDB)\$(INT)

$(DISTDIR)\$(LDB)\$(INT)\rexxsql.dll: rexxsql.dll
	copy rexxsql.dll $(DISTDIR)\$(LDB)\$(INT)

$(DISTDIR)\$(LDB)\$(INT)\rexx$(LDB).dll: rexx$(LDB).dll
	copy rexx$(LDB).dll $(DISTDIR)\$(LDB)\$(INT)
